#!/usr/bin/php
<?php
require_once('wlan.lib.php');

/// Set Wi-Fi country
shell_exec('iw reg set 00');

@file_put_contents('/run/wlan.update', '');

while (1) {

	/// If needed - reload all params from config file
	if (file_exists('/run/wlan.update')) {

		/// Stop all, for release all interfaces
		AP_stop();
		Camera_stop();
		LAN_stop();


		$CONFIG = GetConfig();

		/// CAMERA

		$CAMERA_IFACE = GetParam($CONFIG, 'camera_iface');
		$CAMERA_SSID = GetParam($CONFIG, 'camera_ssid');
		$CAMERA_PASS = GetParam($CONFIG, 'camera_psk');

		shell_exec("killall -q data-receiver");
		shell_exec("killall -q video-receiver");


		/// ACCESS POINT

		$AP_IFACE = GetParam($CONFIG, 'ap_iface');
		$AP_MODE = GetParam($CONFIG, 'ap_mode');
		$AP_CHANNEL = GetParam($CONFIG, 'ap_channel');
		$AP_SSID = GetParam($CONFIG, 'ap_ssid');
		$AP_PSK = GetParam($CONFIG, 'ap_psk');
		$AP_COUNTRY = GetParam($CONFIG, 'ap_country');

		if ($AP_MODE == "2") $AP_MODE = "g";
		if ($AP_MODE == "5") $AP_MODE = "a";

		/// Check Access Point
		if ($AP_IFACE != "") {
			AP_run($AP_IFACE, $AP_MODE, $AP_CHANNEL, $AP_SSID, $AP_PSK, $AP_COUNTRY);
			shell_exec("iptables -t nat -I PREROUTING -i $AP_IFACE --src 0/0 --dst 192.168.1.2 -p tcp --dport 5678 -j REDIRECT --to-ports 6789");
			shell_exec("iptables -t nat -I PREROUTING -i $AP_IFACE --src 0/0 --dst 192.168.1.3 -p udp --dport 9000 -j REDIRECT --to-ports 9000");

			shell_exec("iptables -t nat -I PREROUTING -i $AP_IFACE --src 0/0 --dst 192.168.2.1 -p udp --dport 9003 -j REDIRECT --to-ports 9003");
			shell_exec("iptables -t nat -I PREROUTING -i $AP_IFACE --src 0/0 --dst 192.168.2.1 -p udp --dport 9004 -j REDIRECT --to-ports 9004");
		}


		/// Local Network

		$LAN_IFACE = GetParam($CONFIG, 'wifi_iface');
		$LAN_SSID = GetParam($CONFIG, 'wifi_ssid');
		$LAN_PASS = GetParam($CONFIG, 'wifi_psk');

		if ($LAN_IFACE != "") {
			LAN_run($LAN_IFACE, $LAN_SSID, $LAN_PASS);
		}


		/// Clear flag
		unlink('/run/wlan.update');

		usleep(100000);
	}

	/// Check camera iface
	if ($CAMERA_IFACE != "") {

		$ssid = Camera_getCurrentSsid();

		if ($ssid == "") {

			/// Run Camera Connection
			Camera_run($CAMERA_IFACE, $CAMERA_SSID, $CAMERA_PASS);

			/// Enable packet redirection via camera interface
			shell_exec("iptables -t nat -A POSTROUTING -o $CAMERA_IFACE -j MASQUERADE");
		}
	}

	usleep(1000000);
}

?>
