#!/usr/bin/nodejs

var clientsCount = 0;

// start UDP server 
var udpClient = require('./udp.js');
udpClient.onMessage = function(msg, rinfo) {
	wsServer.send(msg);
}

// start websockets server
var wsServer = require('./wsserver.js');

wsServer.onConnected = function() {
	console.log("data client connected");
}

wsServer.onMessage = function(data) {
	udpClient.sendString(data);
}

wsServer.start(8081, true);

check_clients();

function check_clients() {
	setTimeout(check_clients, 1000);

	// check current clients count
	if (wsServer.sockets) clientsCount = Object.keys(wsServer.sockets).length
	console.log("data clients " + clientsCount);

	if (clientsCount > 0) {
		send_alive();
	}

	send_clients_count(clientsCount);
}

function send_alive() {
	var buf = new Buffer(12 + 2);
	buf[0] = 0x42;
	buf[12] = 0x00;
	buf[13] = 0x01;
	udpClient.send(buf);
}

function send_clients_count(count) {
	var buf = new Buffer(12 + 2);
	buf[0] = 0x42;
	buf[12] = 0x02;
	buf[13] = count & 0xff;
	udpClient.send(buf);
}
