#!/usr/bin/nodejs

var options = {
	width : 640,
	height: 480,
	fps: 30,
	bitrate: 700000,
}

var clientsCount = 0;

// capture stream
var Capture = require('./capture.js');
Capture.onData = function(data) {
	wsServer.send(data);
}

// start websockets server
var wsServer = require('./wsserver.js');
wsServer.onConnected = function() {
	Capture.stop();
	Capture.start(options);
}
wsServer.start(8080, false, options);

setInterval(check_clients, 1000);

function check_clients() {

	// check current clients count
	if (wsServer.sockets) {
		clientsCount = Object.keys(wsServer.sockets).length
	}

	console.log("video clients " + clientsCount);

	if (clientsCount > 0) {
		// clients available, start stream (if was not started)
		if (!Capture.active) Capture.start(options);
	} else {
		// no clients, stop stream (if was started)
		if (Capture.active) Capture.stop();
	}
}
