const MOVEMODE_ABS = 1;
const MOVEMODE_REL = 2;

var zoom_value = 0;
var mouseButtonDown = false;
var moveMode = 0;
var startX = 0, startY = 0;

function send_command(cmd, param, value1, value2) {
	$.post('commands.php?rnd=' + Math.random(), {cmd:cmd, param:param, value1:value1, value2:value2}, function(response, status, xhr) {
		//$('#logwindow').html(response);
	});
}

$(document).ready(function() {

	readWlanStatus();

	$('#movebox').mousemove(function(event) {
		if (!mouseButtonDown) return;

		event.preventDefault();

		if ($("#movemodeswitch").prop('checked')) moveMode = MOVEMODE_ABS; else moveMode = MOVEMODE_REL;

		var windowWidth = parseInt($('#movebox').css('width'));
		var windowHeight = parseInt($('#movebox').css('height'));
		var offsetX = parseInt($('#centralbox').css('left'));
		var offsetY = parseInt($('#centralbox').css('top')) + 30;
		var x = parseInt(event.pageX - offsetX);
		var y = parseInt(event.pageY - offsetY);

		switch (moveMode) {
			case MOVEMODE_ABS:
				x = parseInt(x / windowWidth * 6400 - 3200);
				y = parseInt(y / windowHeight * 1620 - 1300);
				send_command('position', 'move', x, y);
			break;

			case MOVEMODE_REL:
				x = parseInt((x - startX) * 4000 / 600);
				y = parseInt((y - startY) * 4000 / 600);
				send_command('position', 'moverel', x, y);
			break;
		}
	});

	$('#movebox').mousedown(function(event) {
		mouseButtonDown = true;

		event.preventDefault();

		if ($("#movemodeswitch").prop('checked')) moveMode = MOVEMODE_ABS; else moveMode = MOVEMODE_REL;

		var windowWidth = parseInt($('#movebox').css('width'));
		var windowHeight = parseInt($('#movebox').css('height'));
		var offsetX = parseInt($('#centralbox').css('left'));
		var offsetY = parseInt($('#centralbox').css('top')) + 30;
		var x = parseInt(event.pageX - offsetX);
		var y = parseInt(event.pageY - offsetY);

		switch (moveMode) {
			case MOVEMODE_ABS:
				x = parseInt(x / windowWidth * 6400 - 3200);
				y = parseInt(y / windowHeight * 1620 - 1300);
				send_command('position', 'move', x, y);
			break;

			case MOVEMODE_REL:
				startX = x;
				startY = y;
			break;
		}
	});

	$('#movebox').mouseup(function(e) {
		mouseButtonDown = false;

		if ($("#movemodeswitch").prop('checked')) moveMode = MOVEMODE_ABS; else moveMode = MOVEMODE_REL;

		switch (moveMode) {
			case MOVEMODE_ABS:
			break;

			case MOVEMODE_REL:
				send_command('position', 'moverel', 0, 0);
			break;
		}
	});

	$("#movebox").mouseleave(function() {
		mouseButtonDown = false;
		startX = 0;
		startY = 0;
	});


	$('#position_normal').on('click', function() {
		send_command('position', "normal", "", "");
	});
	$('#position_selfie').on('click', function() {
		send_command('position', "selfie", "", "");
	});

	$('#zoom_in').on('mousedown', function() {
		send_command('zoom', "-2", "1", "");
	});
	$('#zoom_in').on('mouseup', function() {
		send_command('zoom', "-2", "0", "");
	});
	$('#zoom_out').on('mousedown', function() {
		send_command('zoom', "-2", "-1", "");
	});
	$('#zoom_out').on('mouseup', function() {
		send_command('zoom', "-2", "0", "");
	});
	$('#opt_zoom_in').on('mousedown', function() {
		send_command('zoom', "-3", "1", "");
	});
	$('#opt_zoom_in').on('mouseup', function() {
		send_command('zoom', "-3", "0", "");
	});
	$('#opt_zoom_out').on('mousedown', function() {
		send_command('zoom', "-3", "-1", "");
	});
	$('#opt_zoom_out').on('mouseup', function() {
		send_command('zoom', "-3", "0", "");
	});
	$('#zoom_slider').on('input', function() {
		var value = $('#zoom_slider').val();
		send_command('zoom', "1", value, "");
	});

	$('#orientation_lock').on('click', function() {
		send_command('orientation', "lock", "", "");
	});
	$('#orientation_unlock').on('click', function() {
		send_command('orientation', "unlock", "", "");
	});	

	$('#pitch_lock').on('click', function() {
		send_command('pitch', "lock", "", "");
	});
	$('#pitch_unlock').on('click', function() {
		send_command('pitch', "unlock", "", "");
	});	

	$('#ae_lock').on('click', function() {
		send_command('exposure', "auto", "lock", "");
	});
	$('#ae_unlock').on('click', function() {
		send_command('exposure', "auto", "unlock", "");
	});

	$('#horizont_cw').on('click', function() {
		send_command('horizont', "cw", "", "");
	});
	$('#horizont_ccw').on('click', function() {
		send_command('horizont', "ccw", "", "");
	});
	$('#horizont_zero').on('click', function() {
		send_command('horizont', "zero", "", "");
	});

	$('#horizont_calibrate').on('click', function() {
		send_command('horizont', "calibrate", "", "");
	});


	$('#param_scenemode').on('change', function() {
		send_command('scenemode', this.value, "", "");
	});
	$('#param_orientation').on('change', function() {
		send_command('orientation', this.value, "", "");
	});
	$('#param_color').on('change', function() {
		send_command('color', this.value, "", "");
	});
	$('#param_scene').on('change', function() {
		send_command('scene', this.value, "", "");
	});
	$('#param_wb').on('change', function() {
		send_command('wb', this.value, "", "");
	});
	$('#param_videomode').on('change', function() {
		send_command('video_mode', this.value, "", "");
	});
	$('#param_shutterspeed').on('change', function() {
		send_command('shutter', this.value, "", "");
	});
	$('#param_aperture').on('change', function() {
		send_command('aperture', this.value, "", "");
	});
	$('#param_iso').on('change', function() {
		send_command('iso', this.value, "", "");
	});
	$('#param_ev').on('change', function() {
		send_command('ev', this.value, "", "");
	});
	$('#param_videores').on('change', function() {
		send_command('video_resolution', this.value, "", "");
	});
	$('#param_aspect').on('change', function() {
		send_command('video_aspect', this.value, "", "");
	});
	$('#cam_mode').on('change', function() {
		send_command('camera', "mode", this.value, "");
	});


	$('#movebox').bind('mousewheel', function(e){
		zoom_value += e.originalEvent.wheelDelta / 120;
		if (zoom_value < 0) zoom_value = 0;
		if (zoom_value > 100) zoom_value = 100;
		send_command('zoom', "", zoom_value, "");
    });
});


function readWlanStatus () {
	var filename = "/tmp/wlanstatus";
	$.post('readfile.php?rnd=' + Math.random(), {filename:filename}, function(response, status, xhr) {
		var json;
		var infoString = "";
		try {
			json = JSON.parse(response);

			if (json.ssid != "") {
				infoString = '"' + json.ssid + '"';
				infoString += ' ' + json.freq + 'Mhz';
				infoString += ' ' + json.quality + '/' + json.quality_max;
				infoString += ' signal ' + json.signal;
			}
		} catch (err) {}

		$(document).prop('title', infoString == "" ? "Cosmostreamer" : infoString);
		$('#statusblock').html(infoString == "" ? "&nbsp" : infoString);
	});

	setTimeout(readWlanStatus, 2000);
}
