var needSettingsRequest = false;
var currentHash = "";

var rcin_int_prev_values = [];

var timer = null;

$(document).ready(function() {

	SetCurrentHash(document.location.hash);
	RequestBoxSettings();

	window.onpopstate = function(event) {
		SetCurrentHash(document.location.hash);
		RequestBoxSettings();
	};

	$('#box_config').on("click", function() {
		var state = $("#config_window").css("display");
		if (state == "block") {
			CloseBoxSettings();
		} else {
			if (GetCurrentHash() == "") SetCurrentHash("#settings");
			RequestBoxSettings();
		}
	});

	$('#close_box_config').on("click", function() {
		CloseBoxSettings();
	});

	$(".bl").on("click", function() {
		SetCurrentHash("#" + $(this).attr('id'));
		OpenBoxSettings(GetCurrentHash());
		//RequestBoxSettings();
	});


	$('#save_key').on('click', function() {
		if (!confirm("Are you sure?")) return;
		var param = $("#field_key").val();
		send_param("license_key", param);
	});	

	$('#save_udp_clients').on('click', function() { send_param("udp_clients", $("#field_udp_clients").val()); });
	$('#save_mpegts_clients').on('click', function() { send_param("mpegts_clients", $("#field_mpegts_clients").val()); });
	$('#save_rtmp_url').on('click', function() { send_param("rtmp_url", $("#field_rtmp_url").val()); });
	$('#save_tcp_port').on('click', function() { send_param("tcp_port", $("#field_tcp_port").val()); });

	$('#field_udp_enabled').on('click', function() { send_param("udp_enabled", $(this).prop("checked")); });
	$('#field_mpegts_enabled').on('click', function() { send_param("mpegts_enabled", $(this).prop("checked")); });
	$('#field_rtmp_enabled').on('click', function() { send_param("rtmp_enabled", $(this).prop("checked")); });
	$('#field_tcp_enabled').on('click', function() { send_param("tcp_enabled", $(this).prop("checked")); });
	$('#field_rtsp_enabled').on('click', function() { send_param("rtsp_enabled", $(this).prop("checked")); });
	$('#field_dvbt_enabled').on('click', function() { send_param("dvbt_enabled", $(this).prop("checked")); });

	$('#hdmimode_test').on('click', function() { send_param2("hdmimode", $("#field_hdmimode").val(), 0); });
	$('#hdmimode_save').on('click', function() { send_param2("hdmimode", $("#field_hdmimode").val(), 1); });

	$('#field_hdmi_enabled').on('click', function() { send_param("hdmi_enabled", $(this).prop("checked")); });
	$('#field_rca_enabled').on('click', function() { send_param("hdmi_enabled", !$(this).prop("checked")); });
	$('#field_osd_enabled').on('click', function() { send_param( "osd_enabled", $(this).prop("checked")); });
	$('#field_hud_enabled').on('click', function() { send_param("hud_enabled", $(this).prop("checked")); });

	$('#field_hflip').on('click', function() { send_param("video_hflip", $(this).prop("checked") ? 1 : 0); });
	$('#field_vflip').on('click', function() { send_param("video_vflip", $(this).prop("checked") ? 1 : 0); });
	$('#field_vfix').on('click', function() { send_param("video_fix", $(this).prop("checked") ? 1 : 0) });

	$('#field_internal_camera_enabled').on('click', function() { send_param("internal_camera_enabled", $(this).prop("checked")); });
	$('#field_internal_camera_fullscreen').on('click', function() { send_param("internal_camera_fullscreen", $(this).prop("checked")); });
	$('#save_osd_borders').on('click', function() { send_param2("osd_borders", $("#field_osd_borders_width").val(), $("#field_osd_borders_height").val()); });
	$('#save_offset').on('click', function() { send_param2("osd_offset", $("#field_top_offset").val(), $("#field_bottom_offset").val()); });

	$('#field_audio_enabled').on('click', function() { send_param("audio_enabled", $(this).prop("checked")); });
	$('#field_autogain_enabled').on('click', function() { send_param("audio_autogain", $(this).prop("checked")); });	
	$('#audiovolume_slider').on('change', function() { send_param("audio_volume", $(this).val() * 10); $("#field_audio_volume").html($(this).val() * 10 + "%"); });
	$('#field_onboard_rec_enabled').on('click', function() { send_param("rec_enabled", $(this).prop("checked") ? 1 : 0); });	

	$('#field_audio_bitrate').on('change', function() { send_param("audio_bitrate", $(this).val()); });

	$('#field_video_bitrate').on('change', function() { send_param("video_bitrate", $(this).val()); });
	$('#field_video_resolution').on('change', function() { send_param("video_resolution", $(this).val()); });
	$('#field_video_transcode').on('click', function() { send_param("video_transcode_enabled", $(this).prop("checked") ? 1 : 0); });

	$('#field_video_stream_disabled').on('click', function() { send_param("disable_video_stream", $(this).prop("checked") ? 1 : 0); });

	$('#field_display_enabled').on('click', function() { send_param("display_enabled", $(this).prop("checked")); });
	$('#field_rcin_enabled').on('click', function() { send_param("rcin_enabled", $(this).prop("checked")); });

	$('.rc_mode').on('change', function() {
		var value1 = $("#field_rc1mode").val().toLowerCase();
		var value2 = $("#field_rc2mode").val().toLowerCase();
		wsSend(JSON.stringify({ cmd:'updateparam', name:'rcin_mode', value:value1, value2:value2 }));
	});

	$('#field_rc_exp').on('click', function() { send_param("rcin_exp", $(this).prop("checked")); });

	$('#rcin_save').on('click', function() {
		var value1 = $("#panspeed_slider").val();
		var value2 = $("#tiltspeed_slider").val();
		var value3 = $("#dutchspeed_slider").val();
		wsSend(JSON.stringify({ cmd:'updateparam', name:'rcin_speed', value:value1.toString(), value2:value2.toString(), value3:value3.toString() }));
	});

	$('#panspeed_slider').on('input', function() { $('#field_pan_speed').html($(this).val() + "%"); });
	$('#tiltspeed_slider').on('input', function() { $('#field_tilt_speed').html($(this).val() + "%"); });
	$('#dutchspeed_slider').on('input', function() { $('#field_dutch_speed').html($(this).val() + "%"); });


	$("#box_restart").on('click', function() {
		if (!confirm("Are you sure?")) return;
		wsSend(JSON.stringify({ cmd:"restart", name:"", value:"" }));
	});

	$("#box_reboot").on('click', function() {
		if (!confirm("Are you sure?")) return;
		wsSend(JSON.stringify({ cmd:"reboot", name:"", value:"" }));
	});

	$("#rc_recalibrate").on('click', function() {
		wsSend(JSON.stringify({ cmd:'rc', name:'recalibrate', value:'' }));
	});

	$("#save_server").on('click', function() {
		var enabled = $("#field_server_enabled").prop("checked");
		var host = $("#field_server_host").val();
		var port = $("#field_server_port").val();
		var user = $("#field_server_user").val();
		var pass = $("#field_server_pass").val();
		var devid = $("#field_server_devid").val();
		send_param_long("server_connection", host, port, user, pass, devid, enabled);
	});

	/// For Wi-Fi

	$("#cam_wifi_list").on('change', function() {
		$("#cam_wifi_ssid_field").val($(this).val());
	});

	$("#lan_wifi_list").on('change', function() {
		$("#wifi_ssid_field").val($(this).val());
	});

	$("#cam_wifi_scan_Button").on('click', function() {
		$("#cam_wifi_list").empty();
		var value1 = $('#cam_wifi_ifacename').prop("selectedIndex");
		wsSend(JSON.stringify({ cmd:"wlan", param:"scan", value:value1.toString() }));
	});

	$("#lan_wifi_scan_Button").on('click', function() {
		$("#lan_wifi_list").empty();
		var value1 = $('#lan_wifi_ifacename').prop("selectedIndex");
		wsSend(JSON.stringify({ cmd:"wlan", param:"scan", value:value1.toString() }));
	});



	$("#cam_wifi_ifacename").on('change', function() {
		var index = $(this).prop("selectedIndex");
		if (index > 0 && $("#lan_wifi_ifacename").prop("selectedIndex") == index) {
			alert($(this).val() + " already used by Network connection");
			$(this).prop("selectedIndex", 0);
			return;
		}
		if (index > 0 && $("#ap_wifi_ifacename").prop("selectedIndex") == index) {
			alert($(this).val() + " already used by Access point");
			$(this).prop("selectedIndex", 0);
			return;
		}
		UpdateWlanBlocks();
	});

	$("#lan_wifi_ifacename").on('change', function() {
		var index = $(this).prop("selectedIndex");
		if (index > 0 && $("#cam_wifi_ifacename").prop("selectedIndex") == index) {
			alert($(this).val() + " already used by Osmo connection");
			$(this).prop("selectedIndex", 0);
			return;
		}
		if (index > 0 && $("#ap_wifi_ifacename").prop("selectedIndex") == index) {
			alert($(this).val() + " already used by Access point");
			$(this).prop("selectedIndex", 0);
			return;
		}
		UpdateWlanBlocks();
	});

	$("#ap_wifi_ifacename").on('change', function() {
		var index = $(this).prop("selectedIndex");
		if (index > 0 && $("#cam_wifi_ifacename").prop("selectedIndex") == index) {
			alert($(this).val() + " already used by Osmo connection");
			$(this).prop("selectedIndex", 0);
			return;
		}
		if (index > 0 && $("#lan_wifi_ifacename").prop("selectedIndex") == index) {
			alert($(this).val() + " already used by Network connection");
			$(this).prop("selectedIndex", 0);
			return;
		}
		UpdateWlanBlocks();
	});


	$("#ap_wifi_mode_field").on('change', function() { FillChannels(); });
	$("#ap_wifi_country_field").on('change', function() { FillChannels(); });


	$("#wifi_save_Button").on('click', function() {
		var ap_channel = "";
		var ap_mode = "";
		var ap_country = $("#ap_wifi_country_field").val();

		if ( $("#ap_wifi_mode_field").prop("selectedIndex") == 0 ) {
			ap_mode = "2.4";
			ap_channel = $("#ap_wifi_channel24_field").val();
		}
		if ( $("#ap_wifi_mode_field").prop("selectedIndex") == 1 ) {
			ap_mode = "5";
			ap_channel = $("#ap_wifi_channel58_field").val();
		}

		if ($("#cam_wifi_ifacename").prop("selectedIndex") > 0) {
			if (($("#cam_wifi_psk_field").val().length > 0) && ($("#cam_wifi_psk_field").val().length < 8)) { alert("OSMO connection password is too short. 8 or more letters needed."); return; }
		}

		if ($("#lan_wifi_ifacename").prop("selectedIndex") > 0) {
			if ($("#wifi_ssid_field").val().length == 0) { alert("Network connection SSID is empty"); return; }
			if ($("#wifi_psk_field").val().length < 8) { alert("Network connection password is too short. 8 or more letters needed."); return; }
		}

		if ($("#ap_wifi_ifacename").prop("selectedIndex") > 0) {
			if ($("#ap_ssid_field").val().length == 0) { alert("Access Point SSID is empty"); return; }
			if ($("#ap_psk_field").val().length < 8) { alert("Access Point password is too short. 8 or more letters needed."); return; }
		}

		if (!confirm("Wi-Fi settings will be changed. Are you sure?")) return;

		var command = {
			cmd:"updateparam",
			name:"wifi",

			value:$("#cam_wifi_ifacename").prop("selectedIndex").toString(),
			value2:$("#cam_wifi_ssid_field").val(),
			value3:$("#cam_wifi_psk_field").val(),

			value4:$("#lan_wifi_ifacename").prop("selectedIndex").toString(),
			value5:$("#wifi_ssid_field").val(),
			value6:$("#wifi_psk_field").val(),

			value7:$("#ap_wifi_ifacename").prop("selectedIndex").toString(),
			value8:$("#ap_ssid_field").val(),
			value9:$("#ap_psk_field").val(),
			value10:ap_mode,
			value11:ap_channel,
			value12:ap_country
		};

		wsSend(JSON.stringify(command));

	});

	/// End for Wi-Fi

	$(".ch_select").each(function(index) {
		$(this).append($('<option>').text(""));
		$(this).append($('<option>').text("menu"));
		$(this).append($('<option>').text("pan"));
		$(this).append($('<option>').text("tilt"));
		$(this).append($('<option>').text("dutch"));
		$(this).append($('<option>').text("digital-zoom"));
		$(this).append($('<option>').text("digital-zoom2"));
		$(this).append($('<option>').text("zoom"));
		$(this).append($('<option>').text("focus"));
		$(this).append($('<option>').text("record"));
		$(this).append($('<option>').text("record-shot"));
		$(this).append($('<option>').text("ev"));
		$(this).append($('<option>').text("focus-pan"));
		$(this).append($('<option>').text("focus-tilt"));
		$(this).append($('<option>').text("iso"));
		$(this).append($('<option>').text("shutter"));
		$(this).append($('<option>').text("aperture"));
		$(this).append($('<option>').text("videomode"));
		$(this).append($('<option>').text("custom-focus-assistant"));
		$(this).append($('<option>').text("center"));
		$(this).append($('<option>').text("intcamera"));
		$(this).append($('<option>').text("osd"));
		$(this).append($('<option>').text("orient-lock"));
		$(this).append($('<option>').text("onboard-rec"));
	});

	$("#rcin_map_clear").on('click', function() {
		$(".ch_select").each(function(index) {
			$(this).val("");
		});
	});

	$("#rcin_map_save").on('click', function() {
		if (!confirm("Are you sure to change channels mapping?")) return;
		var param = "";
		$(".ch_select").each(function(index) {
			param += $(this).val() + ",";
		});

		send_param("rcin_map", param);
	});


	$('#field_control_enabled').on('click', function() {
		var param = $(this).prop("checked");
		send_param("ctrl_enabled", param ? 1 : 0);
	});

	$('#camera_type_save').on('click', function() {
		var param = $('#field_camera_type').prop("selectedIndex");
		if (!confirm("Are you sure to switch camera type to " + $('#field_camera_type').val() + "?")) return;
		//alert(param);
		send_param("camtype", param);
	});

	$('#camera_workmode_save').on('click', function() {
		var param = $('#field_camera_workmode').prop("selectedIndex");
		if (!confirm("Are you sure to switch camera work mode to " + $('#field_camera_workmode').val() + "?")) return;
		send_param("device_mode", param ? 1 : 0);
	});

	$('#camera_coopmode_save').on('click', function() {
		var param = $('#field_camera_coopmode').prop("selectedIndex");
		if (!confirm("Are you sure to switch cooperative mode to " + $('#field_camera_coopmode').val() + "?")) return;
		send_param("coop_mode", param ? 1 : 0);
	});


});

function UpdateWlanBlocks () {
	var index1 = $("#cam_wifi_ifacename").prop("selectedIndex");
	$("#osmo_connection_block").css("display", index1 > 0 ? "block" : "none");

	var index2 = $("#lan_wifi_ifacename").prop("selectedIndex");
	$("#lan_connection_block").css("display", index2 > 0 ? "block" : "none");

	var index3 = $("#ap_wifi_ifacename").prop("selectedIndex");
	$("#ap_connection_block").css("display", index3 > 0 ? "block" : "none");
}

function FillChannels () {
	var country_code = $("#ap_wifi_country_field").val();

	switch (country_code) {
		case "00":
			$("#ap_wifi_channel24_field").empty();
			for (var i = 1; i <= 14; i++) $('#ap_wifi_channel24_field').append($('<option>', { value:i }).text(i));

			$("#ap_wifi_channel58_field").empty();
			var channels58 = [ 36, 38, 40, 42, 44, 46, 48, 52, 56, 60, 64, 100, 104, 108, 112, 116, 120, 124 ];
			for (var i = 0; i < channels58.length; i++) $('#ap_wifi_channel58_field').append($('<option>', { value:channels58[i].toString() }).text(channels58[i].toString()));
		break;

		case "CN":
			$("#ap_wifi_channel24_field").empty();
			for (var i = 1; i <= 13; i++) $('#ap_wifi_channel24_field').append($('<option>', { value:i }).text(i));

			$("#ap_wifi_channel58_field").empty();
			var channels58 = [ 149, 153, 157, 161, 165 ];
			for (var i = 0; i < channels58.length; i++) $('#ap_wifi_channel58_field').append($('<option>', { value:channels58[i].toString() }).text(channels58[i].toString()));
		break;

		case "US":
			$("#ap_wifi_channel24_field").empty();
			for (var i = 1; i <= 11; i++) $('#ap_wifi_channel24_field').append($('<option>', { value:i }).text(i));

			$("#ap_wifi_channel58_field").empty();
			var channels58 = [ 36, 40, 44, 48, 52, 56, 60, 64, 100, 104, 108, 112, 116, 120, 124, 128, 132, 136, 140, 144, 149 ];
			for (var i = 0; i < channels58.length; i++) $('#ap_wifi_channel58_field').append($('<option>', { value:channels58[i].toString() }).text(channels58[i].toString()));
		break;
	}

	var mode = $("#ap_wifi_mode_field").prop("selectedIndex");
	$("#ap_wifi_channel24_field").css("display", mode == 0 ? "inline" : "none");
	$("#ap_wifi_channel58_field").css("display", mode == 1 ? "inline" : "none");
}

function ShowRcMapping(mapping) {
	if (mapping == undefined) return;
	if (mapping == null) return;
	if (mapping == "") return;

	var parts = mapping.split(",");
	for (var i in parts) {
		$("#rcin_value" + i + "_func").val(parts[i]);
	}
}

function ShowRcChannelValue(id, value) {
	$("#rcin_value" + id).html(value);
}

function ShowRcState(state) {
	var state_str = "";
	switch (state) {
		case 0: state_str = ""; break;
		case 1: state_str = "RC calibration"; break;
		case 2: state_str = "RC searching PAN"; break;
		case 3: state_str = "RC searching TILT"; break;
		case 4: state_str = "RC waiting center"; break;
		case 5: state_str = "RC calibration center"; break;
		case 6: state_str = "RC active"; break;
	}

	$(".rc_state").html(state_str);
}

function SetCurrentHash(hash) {
	currentHash = hash;
}

function GetCurrentHash() {
	if (currentHash == undefined) return "";
	if (currentHash == "") return "";
	if (currentHash == "#") return "";
	return currentHash;
}

function RequestBoxSettings() {
	var hash = GetCurrentHash();
	if (hash == "") return;
	needSettingsRequest = true;
	send_command("configrequest", "", "", "");
}

function CheckRcAxis() {
	for (var i = 0; i < 32; i++) {
		var value = parseInt($("#rcin_value" + i).text());
		var delta = Math.abs(value - rcin_int_prev_values[i]);
		$("#rcin_value" + i).css("color", delta > 30 ? "yellow" : "white");
		rcin_int_prev_values[i] = value;
	}
}

function OpenBoxSettings(hash) {
	if (!isFullscreen()) history.pushState(null, "", hash);
	var state = $("#config_window").css("display");
	if (state == "none") {
		$("#config_window").css("display", "block");
		$("#config_window").animate({height:"100%"}, 500);
	}

	ShowChapter(hash);

	$("#close_box_config").css("display","block");
	$("#box_config").css("display","none");

	timer = setInterval(CheckRcAxis, 500);
}

function CloseBoxSettings() {
	if (!isFullscreen()) history.pushState(null, "Main page", "#");
	$("#config_window").animate({height:"0px"}, 500);

	$("#close_box_config").css("display","none");
	$("#box_config").css("display","block");

	setTimeout(function(){$("#config_window").css("display", "none");}, 500);

	if (timer != null) clearInterval(timer);
	timer = null;
}

function ShowChapter(hash) {
	$(".bl").removeClass("active");
	$(hash).addClass("active");

	$(".settingscontent").addClass("hidden");
	$(hash + "_content").removeClass("hidden");
}

function ParseSettings(msg) {
	if (needSettingsRequest) {
		OpenBoxSettings(GetCurrentHash());
	}
	needSettingsRequest = false;

	var text = String.fromCharCode.apply(null, new Uint16Array(msg));
	var json;
	try {
		json = JSON.parse(text);
	    currentSettings = json;
	} catch (e) { 
	    currentSettings = undefined;
		return;
	}

	if (json.cmd == "wlanscan") {
		var tmp = json.value.split(',');
		var iface_index = 0;
		try {
			iface_index = parseInt(json.param);
		} catch (e) {}

		if (iface_index < 1) return;

		if ($("#cam_wifi_ifacename").prop("selectedIndex") == iface_index) {
			for (var i in tmp) $('#cam_wifi_list').append($('<option>', { value:tmp[i] }).text(tmp[i]));
		}

		if ($("#lan_wifi_ifacename").prop("selectedIndex") == iface_index) {
			for (var i in tmp) $('#lan_wifi_list').append($('<option>', { value:tmp[i] }).text(tmp[i]));
		}

		return;
	}

	try {
		if (json.app == "wired") {
			$("#wired").css("display", "block");
			$("#dutch_block").css("display", "block");

			$("#protocols").css("display", "none");
			$("#videoaudio").css("display", "none");
			$("#connection").css("display", "none");
			$("#server").css("display", "none");
		}
		else if (json.app == "pocket") {
			$("#wired").css("display", "none");
			$("#protocols").css("display", "none");
			$("#videoaudio").css("display", "none");
			$("#connection").css("display", "none");
			$("#server").css("display", "none");
			$("#dutch_block").css("display", "block");
		} else {
			$("#wired").css("display", "none");
			$("#dutch_block").css("display", "none");

			$("#protocols").css("display", "block");
			$("#videoaudio").css("display", "block");
			$("#connection").css("display", "block");
			$("#server").css("display", "block");
		}
	} catch (e) {}

	$("#field_serial").html(json.sn);
	$("#field_key").val(json.key);

	var cam_iface_id = 0;
	try { cam_iface_id = parseInt(json.cam_iface); } catch (e) { }

	var lan_iface_id = 0;
	try { lan_iface_id = parseInt(json.lan_iface); } catch (e) { }

	var ap_iface_id = 0;
	try { ap_iface_id = parseInt(json.ap_iface); } catch (e) { }

	$("#cam_wifi_ifacename").prop("selectedIndex", cam_iface_id);
	$("#cam_wifi_ssid_field").val(json.cam_ssid);
	$("#cam_wifi_psk_field").val(json.cam_psk);

	$("#lan_wifi_ifacename").prop("selectedIndex", lan_iface_id);
	$("#wifi_ssid_field").val(json.lan_ssid);
	$("#wifi_psk_field").val(json.lan_psk);

	$("#ap_wifi_ifacename").prop("selectedIndex", ap_iface_id);
	$("#ap_ssid_field").val(json.ap_ssid);
	$("#ap_psk_field").val(json.ap_psk);

	$("#ap_wifi_country_field").val(json.ap_country);

	if (json.ap_mode == "2") {
		$("#ap_wifi_mode_field").prop("selectedIndex", 0);
		FillChannels();
		$("#ap_wifi_channel24_field").val(json.ap_channel);
	}
	if (json.ap_mode == "5") {
		$("#ap_wifi_mode_field").prop("selectedIndex", 1);
		FillChannels();
		$("#ap_wifi_channel58_field").val(json.ap_channel);
	}

	var ifaces = "";
	for (var i in json.ifaces) {
		ifaces += json.ifaces[i].name + " " + json.ifaces[i].addr + "<br>";

		switch (json.ifaces[i].name) {
			case "wifi0":
				if ($("#cam_wifi_ifacename").prop("selectedIndex") == 1) $("#cam_wifi_iface").html(json.ifaces[i].name + " " + json.ifaces[i].addr);
				if ($("#lan_wifi_ifacename").prop("selectedIndex") == 1) $("#lan_wifi_iface").html(json.ifaces[i].name + " " + json.ifaces[i].addr);
				if ($("#ap_wifi_ifacename").prop("selectedIndex") == 1) $("#ap_wifi_iface").html(json.ifaces[i].name + " " + json.ifaces[i].addr);
			break;

			case "wlan0":
				if ($("#cam_wifi_ifacename").prop("selectedIndex") == 2) $("#cam_wifi_iface").html(json.ifaces[i].name + " " + json.ifaces[i].addr);
				if ($("#lan_wifi_ifacename").prop("selectedIndex") == 2) $("#lan_wifi_iface").html(json.ifaces[i].name + " " + json.ifaces[i].addr);
				if ($("#ap_wifi_ifacename").prop("selectedIndex") == 2) $("#ap_wifi_iface").html(json.ifaces[i].name + " " + json.ifaces[i].addr);
			break;
		}
	}

	$("#field_ifaces").html(ifaces);

	UpdateWlanBlocks();

	$("#field_udp_enabled").prop("checked", json.udp_en);
	$("#field_udp_clients").val(json.udp_clients);

	$("#field_mpegts_enabled").prop("checked", json.mpegts_en);
	$("#field_mpegts_clients").val(json.mpegts_clients);

	$("#field_rtmp_enabled").prop("checked", json.rtmp_en);
	$("#field_rtmp_url").val(json.rtmp_url);
	
	$("#field_tcp_enabled").prop("checked", json.tcp_en);
	$("#field_tcp_port").val(json.tcp_port);

	$("#field_rtsp_enabled").prop("checked", json.rtsp_en);
	$("#field_dvbt_enabled").prop("checked", json.dvbt_en);

	$("#field_video_bitrate").val(json.vbitrate);
	$("#field_video_resolution").val(json.vw + "x"+ json.vh);
	$("#field_video_transcode").prop("checked", json.vte);

	$("#field_video_stream_disabled").prop("checked", json.v_dis);

	$("#field_hflip").prop("checked", json.v_hf);
	$("#field_vflip").prop("checked", json.v_vf);
	$("#field_vfix").prop("checked", json.v_f);

	$("#field_audio_bitrate").val(json.abitrate);

	$("#field_audio_enabled").prop("checked", json.audio_en);
	$("#field_autogain_enabled").prop("checked", json.again);
	$("#field_audio_volume").html(json.avol + "%");
	$("#audiovolume_slider").val(json.avol / 10);

	$("#field_onboard_rec_enabled").prop("checked", json.rec_en ? "checked" : "");	
	
	$("#field_hdmi_enabled").prop("checked", json.hdmistate);
	$("#field_rca_enabled").prop("checked", !json.hdmistate);
	$("#field_osd_enabled").prop("checked", json.osd_en);
	$("#field_hud_enabled").prop("checked", json.hud_en);
	$("#field_internal_camera_enabled").prop("checked", json.ic_en);
	$("#field_internal_camera_fullscreen").prop("checked", json.ic_fs);

	$("#field_osd_borders_width").val(json.osdbrdw);
	$("#field_osd_borders_height").val(json.osdbrdh);
	$("#field_top_offset").val(json.osdtof);
	$("#field_bottom_offset").val(json.osdbof);

	$("#field_display_enabled").prop("checked", json.disp_en);
	$("#field_rcin_enabled").prop("checked", json.rcin_en);
	$("#field_md_ass_enabled").prop("checked", json.fa_en);
	$("#field_rc_exp").prop("checked", json.rcin_exp);


	if (json.rcin_mode == "pwm") $("#field_rc1mode").prop("selectedIndex", 1);
	else
	if (json.rcin_mode == "ppm") $("#field_rc1mode").prop("selectedIndex", 2);
	else $("#field_rc1mode").prop("selectedIndex", 0);

	if (json.rcin2_mode == "sbus") $("#field_rc2mode").prop("selectedIndex", 1);
	else
	if (json.rcin2_mode == "ppm") $("#field_rc2mode").prop("selectedIndex", 2);
	else $("#field_rc2mode").prop("selectedIndex", 0);


	ShowRcMapping(json.rcin_map);

	$("#field_pan_speed").html(json.rcin_pan + "%");
	$("#panspeed_slider").val(json.rcin_pan);
		
	$("#field_tilt_speed").html(json.rcin_tilt + "%");
	$("#tiltspeed_slider").val(json.rcin_tilt);

	$("#field_dutch_speed").html(json.rcin_dutch + "%");
	$("#dutchspeed_slider").val(json.rcin_dutch);

	$("#field_server_enabled").prop("checked", json.s1);
	$("#field_server_host").val(json.s2);
	$("#field_server_port").val(json.s3);
	$("#field_server_user").val(json.s4);
	$("#field_server_pass").val(json.s5);
	$("#field_server_devid").val(json.s6);

	// for Wired only
	$("#field_control_enabled").prop("checked", json.ctrl_en);
	$("#field_camera_type").prop('selectedIndex', json.camtype);
	$("#field_camera_workmode").prop('selectedIndex', json.dmode);
	$("#field_camera_coopmode").prop('selectedIndex', json.cmode);
}
