var ws = undefined;
var connected = false;

$(document).ready(function() {
	if(typeof(WebSocket)=="undefined") {
		// no websockets in this browser
	} else {
		tryConnect();
	}
});

function tryConnect() {
	setTimeout(tryConnect, 5000);
	if (connected) return;
	doConnect();
}

function doConnect() {
	if (ws != undefined) {
		ws.close();
		ws = undefined;
	}

	// start websockets connection
	ws = new WebSocket("ws://" + document.location.host + ":8081");
	ws.binaryType = "arraybuffer";

	ShowMainMessage("trying to connect...");

	ws.onmessage = function(event) {
		ParseMessage(event.data);
	}

	ws.onopen = function(event) {
		ShowMainMessage();
		connected = true;
		//StartPlayer();

		if (needSettingsRequest) RequestBoxSettings();
	}

	ws.onerror = function(e) {
		ShowMainMessage("disconnected");
		connected = false;
	}

	ws.onclose = function() {
		ShowMainMessage("disconnected");
		connected = false;
	}
}

function wsSend(cmd) {
	if (!connected)  return;
	var headerarr = new Uint8Array(12);
	headerarr[0] = 0x42;
	var bodyarr = str2ab(cmd);
	var result = AppendBuffer(headerarr, bodyarr);
	ws.send(result);

	cmd = null;
	headerarr = null;
	bodyarr = null;
	result = null;
}

function send_command(cmd, param, value1, value2) {
	//setlog(cmd + " " + param + " " + value1 + " " + value2);
	wsSend(JSON.stringify({ cmd:cmd, param:param, value1:value1.toString(), value2:value2.toString() }));
}

function send_param(name, value) {
	// send new param value
	wsSend(JSON.stringify({ cmd:"updateparam", name:name, value:value.toString() }));
	// request updated config
	setTimeout(ConfigRequest, 1000);
}

function send_param2(name, value, value2) {
	// send new param value
	wsSend(JSON.stringify({ cmd:"updateparam", name:name, value:value.toString(), value2:value2.toString() }));
	// request updated config
	setTimeout(ConfigRequest, 1000);
}

function send_param_long(name, value, value2, value3, value4, value5, value6) {
	// send new param value
	wsSend(JSON.stringify({ cmd:"updateparam", name:name, value:value.toString(), value2:value2.toString(), value3:value3.toString(), value4:value4.toString(), value5:value5.toString(), value6:value6.toString() }));
	// request updated config
	setTimeout(ConfigRequest, 1000);
}

function ConfigRequest() {
	send_command("configrequest", "", "", "");
}


function AppendBuffer(buffer1, buffer2) {
  var tmp = new Uint8Array(buffer1.byteLength + buffer2.byteLength);
  tmp.set(new Uint8Array(buffer1), 0);
  tmp.set(new Uint8Array(buffer2), buffer1.byteLength);
  return tmp;
}

function str2ab(str) {
	var bufView = new Uint8Array(str.length);
	for (var i = 0, strLen = str.length; i < strLen; i++) {
		bufView[i] = str.charCodeAt(i);
	}
	return bufView;
}
